VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "shdocvw.dll"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4995
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5640
   LinkTopic       =   "Form1"
   ScaleHeight     =   4995
   ScaleWidth      =   5640
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox ck_UnloadWB 
      Caption         =   "Unload WebBrowser for each file"
      Height          =   255
      Left            =   1740
      TabIndex        =   2
      Top             =   120
      Value           =   1  'Checked
      Width           =   2655
   End
   Begin VB.CommandButton bt_RandomColors 
      Caption         =   "Random Colors"
      Height          =   375
      Left            =   180
      TabIndex        =   1
      Top             =   60
      Width           =   1455
   End
   Begin SHDocVwCtl.WebBrowser web 
      Height          =   3315
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   540
      Visible         =   0   'False
      Width           =   3615
      ExtentX         =   6376
      ExtentY         =   5847
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   ""
   End
   Begin MSComDlg.CommonDialog dlg_Open 
      Left            =   4140
      Top             =   840
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "vdx"
      DialogTitle     =   "Open a Visio file"
      Filter          =   "Visio (*.vsd;*.vdx)|*.vsd;*.vdx|Any(*.*)|*.*"
      FilterIndex     =   1
   End
   Begin VB.Menu mm_File 
      Caption         =   "&File"
      NegotiatePosition=   1  'Left
      Begin VB.Menu mi_Open 
         Caption         =   "Open File To Web Browser Control"
      End
      Begin VB.Menu mi_Save 
         Caption         =   "&Save"
      End
      Begin VB.Menu mi_SaveAs 
         Caption         =   "Save&As"
      End
      Begin VB.Menu mi_Quit 
         Caption         =   "&Quit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim VisApp As Visio.Application

'---------------------------------
Private Sub Form_Resize()
'---------------------------------
Dim W As Long, H As Long
  W = Me.ScaleWidth
  H = Me.ScaleHeight
    
  If (W > 20) And (H > 20) Then
    web(0).Width = W - 10
    web(0).Height = H - web(0).Top - 10
  End If
  MakeWeb1MatchWeb0
End Sub

'---------------------------------
Private Sub MakeWeb1MatchWeb0()
'---------------------------------
Dim AWeb As WebBrowser
  On Error Resume Next
  Set AWeb = web(1)
  If Not (AWeb Is Nothing) Then
    AWeb.Left = web(0).Left
    AWeb.Top = web(0).Top
    AWeb.Width = web(0).Width
    AWeb.Height = web(0).Height
  End If
End Sub

'---------------------------------
Private Sub mi_Open_Click()
'---------------------------------
Dim FilePath As String
  On Error GoTo done
  dlg_Open.CancelError = True
  dlg_Open.Flags = cdlOFNPathMustExist Or cdlOFNFileMustExist
  dlg_Open.ShowOpen
  FilePath = dlg_Open.FileName
  
  LoadFile FilePath
done:
End Sub

'---------------------------------
Private Sub mi_Quit_Click()
'---------------------------------
  Unload Me
End Sub

'---------------------------------
Private Sub LoadFile(FilePath As String)
'---------------------------------
Dim N As Long
  ' Dump existing web browser to ensure no Visio running
  
  Set VisApp = Nothing
  
  '-------------------------------------
  ' Delete web(1) to avoid holding multi
  ' Visio instances open.
  '-------------------------------------
  
  If ck_UnloadWB Then
    If web.Count >= 2 Then
      Unload web(1)
    End If
  End If
  
  If web.Count < 2 Then
    Load web(1)
    web(1).Visible = True
    MakeWeb1MatchWeb0
  End If
  
  If web.Count >= 2 Then
    '-------------------------------
    ' Load the Visio file
    '-------------------------------
    web(1).Navigate FilePath
    '-------------------------------
    ' Wait for WebBrowser to settle
    '-------------------------------
    N = 0
    While web(1).ReadyState <> READYSTATE_COMPLETE
      DoEvents
      N = N + 1
    Wend
    
    '-------------------------
    ' Get instance of Visio
    '-------------------------
    
    While VisApp Is Nothing
      DoEvents
      On Error Resume Next
      Set VisApp = GetObject(, "visio.application")
      On Error GoTo 0
    Wend
    
    If VisApp Is Nothing Then
      MsgBox "Couldn't get running instance of Visio"
      GoTo done
    End If
  End If
done:
End Sub

'---------------------------------
Private Sub bt_RandomColors_Click()
'---------------------------------
Dim APage As Visio.Page
Dim AShape As Visio.Shape
Dim NewColor As Integer
  
  Set APage = VisApp.ActivePage
  If APage Is Nothing Then
    MsgBox "No ActivePage"
    GoTo done
  End If
  
  For Each AShape In APage.Shapes
    NewColor = Int(Rnd(3234.876) * 16)
    AShape.Cells("FillForegnd") = NewColor
  Next AShape
done:
End Sub

'---------------------------------
Private Sub mi_Save_Click()
'---------------------------------
Dim ADoc As Visio.Document
 
  Set ADoc = VisApp.ActiveDocument
  If ADoc Is Nothing Then
    MsgBox "No ActiveDocument"
    GoTo done
  End If
  
  ADoc.Save
  Debug.Print Err.Description
done:
End Sub

'---------------------------------
Private Sub mi_SaveAs_Click()
'---------------------------------
Dim VisApp As Visio.Application
  
  Set ADoc = VisApp.ActiveDocument
  If ADoc Is Nothing Then
    MsgBox "No ActiveDocument"
    GoTo done
  End If
  
  ADoc.SaveAs "d:\junk\Fred.vdx"
  Debug.Print Err.Description
done:
End Sub


