VERSION 5.00
Begin VB.Form Tfm_DnD 
   Caption         =   "Drag and Drop demo"
   ClientHeight    =   5025
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5100
   LinkTopic       =   "Form1"
   ScaleHeight     =   5025
   ScaleWidth      =   5100
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bt_DisableDrop 
      Caption         =   "Disable Drop"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   540
      Width           =   1575
   End
   Begin VB.ListBox List1 
      Height          =   3570
      Left            =   0
      OLEDropMode     =   1  'Manual
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   1020
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "Drag Masters or Shapes to/from this list"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   60
      Width           =   4035
   End
End
Attribute VB_Name = "Tfm_DnD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Event OnQueryUnload()
Public SessionId As Long

'-----------------------------------------
' Drag and Drop Related
'-----------------------------------------
Dim m_CFObjectDescriptorConst As Long
Dim m_CFVisioMasterConst As Long
Dim m_CFVisioShapeConst As Long

'---------------------------------
Private Sub bt_DisableDrop_Click()
'---------------------------------
  List1.OLEDropMode = 0
End Sub

'---------------------------------
Private Sub Form_Initialize()
'---------------------------------
  ' Set HostWindow = Nothing
End Sub

'---------------------------------
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'---------------------------------
  RaiseEvent OnQueryUnload
End Sub

'---------------------------------
Private Sub Form_Unload(Cancel As Integer)
'---------------------------------
  SendEndSession SessionId
 ' Set fm_DnD = Nothing ' try to force it to go away
End Sub

'---------------------------------
Private Sub Form_Terminate()
'---------------------------------
' Note: don't mention "Me" here or we'll autoinstance another form
 ' MsgBox " Form.Terminate Anchored"
 
 ' SendTraceMessage "  Form.Terminate for DnD window"
End Sub

'---------------------------------
Private Sub Form_Resize()
'---------------------------------
Dim W As Long, H As Long

  W = Me.ScaleWidth
  H = Me.ScaleHeight
  
  If (W > 100) And (H > 100) Then
    List1.Width = W - List1.left
    List1.Height = H - List1.top - 10
  End If
End Sub


'=====================================================
' Drag and Drop functionality
'=====================================================
'----------------------------------------------------
Private Sub List1_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, y As Single)
'----------------------------------------------------
Dim bytes() As Byte, N As Integer, S As String, b As Byte
Dim SS(3) As String, C As String, Ix As Integer

  'Text1.Text = ""
 '
  'If Data.GetFormat(vbCFText) Then
  '  S = Data.GetData(vbCFText)
  '  Text1.Text = S
  'End If
  
  If Data.GetFormat(CFObjectDescriptorConst) Then
    ' Text1.Text = "Object Descriptor"
    bytes = Data.GetData(CFObjectDescriptorConst)
    S = ""
    N = 53
    b = bytes(N)
    While b <> 0
      S = S + Chr(b)
      N = N + 2
      b = bytes(N)
    Wend
    N = N + 2
    b = bytes(N)
    S = S + "\"
    While b <> 0
      S = S + Chr(b)
      N = N + 2
      b = bytes(N)
    Wend
  End If
  
  For Ix = 1 To 3
    SS(Ix) = ""
  Next Ix
  Ix = 1
  For N = Len(S) To 1 Step -1
    C = Mid$(S, N, 1)
    Select Case C
      Case "\"
        Ix = Ix + 1
        If Ix > 3 Then GoTo done
      Case Else
        SS(Ix) = C + SS(Ix)
    End Select
  Next N
done:
  If SS(2) = "Stencil" Then
    S = "Stencil|" + SS(3) + "|" + SS(1)
  End If
  
  If SS(3) = "Drawing" Then
    If left$(SS(2), 1) = "~" Then
      SS(2) = Mid$(SS(2), 2, 1000)
    End If
    S = "Page|" + SS(2) + "|" + SS(1)
  End If
    
  List1.AddItem S
skipit:
  Effect = vbDropEffectCopy
End Sub

'----------------------------------------------------
Private Sub List1_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, y As Single, State As Integer)
'----------------------------------------------------
  Effect = vbDropEffectCopy
End Sub

'-----------------------------------------------
Private Function CFObjectDescriptorConst() As Long
'-----------------------------------------------
  If m_CFObjectDescriptorConst = 0 Then
    m_CFObjectDescriptorConst = GetCFFormat("Object Descriptor")
  End If
  CFObjectDescriptorConst = m_CFObjectDescriptorConst
End Function

'-----------------------------------------------
Private Function GetCFFormat(FormatName As String) As Long
'-----------------------------------------------
  GetCFFormat = RegisterClipboardFormat(FormatName)
End Function

'-----------------------------------------------
Private Function CFVisioMasterConst() As Long
'-----------------------------------------------
  If m_CFVisioMasterConst = 0 Then
    m_CFVisioMasterConst = GetCFFormat("VISIO 6.0 Masters")
  End If
  CFVisioMasterConst = m_CFVisioMasterConst
End Function

'-----------------------------------------------
Private Function CFVisioShapeConst() As Long
'-----------------------------------------------
  If m_CFVisioShapeConst = 0 Then
    m_CFVisioShapeConst = GetCFFormat("VISIO 6.0 Shapes")
  End If
  CFVisioShapeConst = m_CFVisioShapeConst
End Function

'===================================================
' Drag SourceHandler
'===================================================

'----------------------------------------------------
Private Sub List1_MouseDown(Button As Integer, Shift As Integer, X As Single, y As Single)
'----------------------------------------------------
Dim LI As Integer
  LI = List1.ListIndex
  If LI <> -1 Then
    List1.OLEDrag
  End If
End Sub

'----------------------------------------------------
Private Sub List1_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
'----------------------------------------------------
Dim S As String, LI As Integer, SelItemParts() As String
Dim AMaster As Visio.Master, AShape As Visio.Shape
Dim DObj As IDataObject
Dim bytes() As Byte
Dim AStgMedium As STGMEDIUM, AFormatEtc As FORMATETC
Dim HR As Long
Dim MemHandle As Long, MemSize As Long, MemPointer As Long

  LI = List1.ListIndex
  If LI <> -1 Then
    S = List1.List(LI)
    SelItemParts = Split(S, "|", -1)
    Select Case SelItemParts(0)
      Case "Stencil"
        S = "Stencil"
        Set AMaster = RetrieveMaster(SelItemParts(1), SelItemParts(2))
        If AMaster Is Nothing Then GoTo skipit
        
        Set DObj = AMaster ' retrieves IDataObject interface to Master
        
        AFormatEtc.cfFormat = CFVisioMasterConst
        
        AFormatEtc.dwAspect = DVASPECT_CONTENT
        AFormatEtc.lindex = -1
        AFormatEtc.pDVTargetDevice = 0
        AFormatEtc.lTyMed = TYMED_HGLOBAL
        HR = DObj.GetData(AFormatEtc, AStgMedium)
        If HR <> 0 Then MsgBox "Error in GetData"
        
        MemHandle = AStgMedium.pData
        MemPointer = GlobalLock(MemHandle)
        MemSize = GlobalSize(MemHandle)
        
        ReDim bytes(MemSize)
        CopyMem bytes(0), ByVal MemPointer, MemSize
        HR = GlobalUnlock(MemHandle)
        GlobalFree (MemHandle)
        ReleaseStgMedium AStgMedium
       
        Data.SetData bytes, CFVisioMasterConst
        
      Case "Page"
        S = "Page"
        Set AShape = RetrieveShape(SelItemParts(1), SelItemParts(2))
        If AShape Is Nothing Then GoTo skipit
        
        Set DObj = AShape ' retrieves IDataObject interface to Shape
        
        AFormatEtc.cfFormat = CFVisioShapeConst
        
        AFormatEtc.dwAspect = DVASPECT_CONTENT
        AFormatEtc.lindex = -1
        AFormatEtc.pDVTargetDevice = 0
        AFormatEtc.lTyMed = TYMED_HGLOBAL
        HR = DObj.GetData(AFormatEtc, AStgMedium)
        If HR <> 0 Then MsgBox "Error in GetData"
        
        MemHandle = AStgMedium.pData
        MemPointer = GlobalLock(MemHandle)
        MemSize = GlobalSize(MemHandle)
        
        ReDim bytes(MemSize)
        CopyMem bytes(0), ByVal MemPointer, MemSize
        HR = GlobalUnlock(MemHandle)
        GlobalFree (MemHandle)
        ReleaseStgMedium AStgMedium
       
        Data.SetData bytes, CFVisioShapeConst
        
      Case Else
        Data.SetData S, vbCFText
    End Select
    
    AllowedEffects = vbDropEffectMove Or vbDropEffectCopy
  End If
skipit:
End Sub

'----------------------------------------------------
'Private Sub List1_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
'----------------------------------------------------
'
'End Sub

'----------------------------------------------------
Private Sub List1_OLESetData(Data As DataObject, DataFormat As Integer)
'----------------------------------------------------
Dim S As String
  If DataFormat = vbCFText Then
    S = "Just a test"
    Data.SetData S, vbCFText
  End If
End Sub

'----------------------------------------------------
Private Sub List1_OLECompleteDrag(Effect As Long)
'----------------------------------------------------
' Do nothing
End Sub

'======================================
' Support
'======================================

'----------------------------------------------------
Private Function RetrieveMaster(StencilName As String, MasterName As String) As Visio.Master
'----------------------------------------------------
Dim AMaster As Visio.Master
Dim ADoc As Visio.Document

  Set ADoc = glo.VisioApp.Documents(StencilName)
  Set AMaster = ADoc.Masters(MasterName)
  Set RetrieveMaster = AMaster
End Function

'----------------------------------------------------
Private Function RetrieveShape(PageName As String, ShapeName As String) As Visio.Shape
'----------------------------------------------------
Dim APage As Visio.Page, AShape As Visio.Shape
Dim ADoc As Visio.Document

  On Error Resume Next
  ' Assume active document since we're using anchored window
  Set ADoc = glo.VisioApp.ActiveDocument
  Set APage = ADoc.Pages(PageName)
  Set AShape = APage.Shapes(ShapeName)
  Set RetrieveShape = AShape
End Function

